import { useQuery } from "@tanstack/react-query"
import { Outlets } from "../../types/services/outlet"
import { api } from "../api"

interface OutletsQueryParams {
  page?: number
  limit?: number
  search?: string
}

export function useOutlets(params: OutletsQueryParams = {}) {
  const { page = 1, limit = 10, search = '', ...filters } = params

  return useQuery<Outlets>({
    queryKey: ['outlets', { page, limit, search, ...filters }],
    queryFn: async () => {
      const queryParams = new URLSearchParams()

      queryParams.append('page', page.toString())
      queryParams.append('limit', limit.toString())

      if (search) {
        queryParams.append('search', search)
      }

      Object.entries(filters).forEach(([key, value]) => {
        if (value !== undefined && value !== null && value !== '') {
          queryParams.append(key, value.toString())
        }
      })

      const res = await api.get(`/outlets/list?${queryParams.toString()}`)
      return res.data.data
    },
  })
}
